#include <QtWidgets>

class MyWidget : public QMainWindow
{
    Q_OBJECT
public:
    MyWidget(QWidget *parent = 0) : QMainWindow(parent)
    {
        widget = new QWidget(this);
        widget->setAutoFillBackground(true);
        QPalette pal = widget->palette();
        pal.setColor(QPalette::Background, Qt::red);
        widget->setPalette(pal);
        widget->resize(200, 200);
        QTimer::singleShot(5000, this, SLOT(resizeTheWidget()));
    }
public slots:
    void resizeTheWidget()
    {
        widget->resize(0,0);
        update();
    }
private:
    QWidget *widget;
};

#include "main.moc"

int main(int argc, char **argv)
{
    QApplication a(argc, argv);
    MyWidget w;
    w.show();
    return a.exec();
}